#!/usr/bin/ruby
require 'socket'
require 'thread'
require './common'

$server_host  = ARGV.shift
$server_port  = ARGV.shift
$port         = ARGV.shift
$upload_dir   = "./up/"
$download_dir = "./down/"

class P4UClient
  def initialize
    # OC
    @server = TCPSocket.open($server_host, $server_port)
    @listen = TCPServer.open($port)
    $host = @server.gets.chop
    puts("+ accepted")
    # Oǂݍ
    @uploads = []
    return unless File.exist?("upload.ini")
    File.open("upload.ini", "r") {|f|
      while line = f.gets do
        info = FileInfo.create(line.chop)
        add_file(info) if info
      end
    }
  end
  
  def main
    t = Thread.new {
      send_listen
    }
    local_session
    t.kill
  end
  
  def finalize
    # O
    File.open("upload.ini", "w") {|f|
      while @uploads.size > 0 do
        info = @uploads.first
        f.puts(info.name)
        del_file(info)
      end
    }
    # \Pbg
    @listen.close if @listen
    @server.close if @server
    puts("+ closed")
  end
  
  # MZbV
  def send_listen
    while true do
      Thread.new(@listen.accept) {|s|
        send_session(s)
      }
    end
  end
  
  # MZbV
  def send_session(sock)
    begin
      # t@C𒊏o
      hash = sock.gets.chop
      array = @uploads.clone
      array.delete_if {|f|
        f.hash != hash
      }
      info = array.first
      # t@C𑗐M
      puts("+ sending #{info.name}")
      File.open($upload_dir + info.name, "rb") {|f|
        remain = info.size
        while remain > 0 do
          data = f.read([65536, remain].min)
          sock.write(data)
          remain -= [65536, remain].min
        end
      }
      puts("+ #{info.name} sended")
    rescue
      puts("! #{info.name} sending failed")
    ensure
      sock.close
    end
  end
  
  # [JZbV
  def local_session
    while line = gets do
      case line.chop
      when /^add\s+(\S.*)$/
        info = FileInfo.create($1)
        add_file(info)
      when /^del\s+(\S.*)$/
        info = FileInfo.create($1)
        del_file(info)
      when /^ls(?:\s+(\S+))?$/
        dir = $1 || "."
        get_list(dir)
      when /^get\s+([0-9a-f]{32})$/
        Thread.new($1) {|hash|
          recv_session(hash)
        }
      when /^quit$/
        break
      else
        puts("! undefined operation")
      end
    end
  end
  
  # t@Cǉ
  def add_file(info)
    if info then
      data = info.to_string
      @server.puts("ADD #{data}")
      @uploads.push(info)
      puts(@server.gets)
    else
      puts("! no such a file")
    end
  end
  
  # t@C폜
  def del_file(info)
    if info then
      data = info.to_string
      @server.puts("DEL #{data}")
      @uploads.delete(info)
      puts(@server.gets)
    else
      puts("! no such a file")
    end
  end
  
  # MZbV
  def recv_session(hash)
    begin
      # t@Co
      @server.puts("INFO #{hash}")
      size = @server.gets.chop.to_i
      array = []
      size.times {
        info = @server.gets.chop.to_info
        array.push(info)
      }
      info = array.first
      # t@CM
      puts("+ receiving #{info.name}")
      sock = TCPSocket.open(info.host, info.port)
      sock.puts(info.hash)
      File.open($download_dir + info.name, "wb") {|f|
        remain = info.size
        while remain > 0 do
          data = sock.read([65536, remain].min)
          f.write(data)
          remain -= [65536, remain].min
        end
      }
      sock.close
      puts("+ #{info.name} received")
    rescue
      puts("! #{info.name} receiving failed")
    end
  end
  
  # t@C
  def get_list(word)
    @server.puts("LS #{word}")
    size = @server.gets.chop.to_i
    size.times {
      info = @server.gets.chop.to_info
      puts("+ #{info.name} (#{info.hash}) #{info.size} bytes")
    }
    puts("! no such a file") if size == 0
  end
end

begin
  client = P4UClient.new
  client.main
rescue
  puts("#{$!}")
ensure
  client.finalize
  exit(0)
end
