#!/usr/bin/ruby
require 'digest/md5'

class FileInfo
  def initialize(name, size, hash, host, port)
    @name, @size, @hash, @host, @port = name, size, hash, host, port
  end
  
  # t@C -> FileInfo
  def self.create(name)
    path = $upload_dir + name
    if File.exist?(path)
      digest = Digest::MD5.new
      File.open(path, "rb") {|f|
        while data = f.read(65536) do
          digest << data
        end
      }
      size = File.size(path)
      hash = digest.hexdigest
      new(name, size, hash, $host, $port)
    else
      nil
    end
  end
  
  # FileInfo -> String
  def to_string
    "#{@name}//#{@size}//#{@hash}//#{@host}//#{@port}"
  end
  
  def ==(other)
    @hash == other.hash && @host == other.host && @port == other.port
  end
  
  def <=>(other)
    @name <=> other.name
  end
  
  attr_accessor :name, :size, :hash, :host, :port
end

class String
  # String -> FileInfo
  def to_info
    array = split('//')
    name, size, hash, host, port = array[0], array[1].to_i, array[2], array[3], array[4].to_i
    FileInfo.new(name, size, hash, host, port)
  end
end
